#! /bin/sh

MNTDIR=testmnt

set -e

# Create the filesystem
dd if=/dev/zero of=virtdev count=128
losetup /dev/loop0 virtdev
mkfs.minix /dev/loop0

# Mount the filesystem
mkdir -p $MNTDIR
mount -t minix /dev/loop0 $MNTDIR

# Create the sparse file plus a test file
./mmap-nospc $MNTDIR/sparse-file reference-file

# Remount the filesystem to invalidate page cache
umount /dev/loop0
mount -t minix /dev/loop0 $MNTDIR

# Check the files
if ! cmp $MNTDIR/sparse-file reference-file; then
    echo "Ha! Where did the data go?"
    status=1
else
    status=0
fi

# Clean up
umount /dev/loop0
losetup -d /dev/loop0
rmdir $MNTDIR

exit $status
